]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Merge branch 'master' of github.com:RichiH/vcsh
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index d583dbc1a4ec1d0f8966fed25134f6f7aa497feb..6fa6644aaed8b2462fe7070f53451ae12197675b 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -14,19 +14,18 @@ help() {
          [<repo>]       Clone from an existing repository
    help                 Display this help text
    delete               Delete an existing repository
+   exit                 Exit repository; unset ENV
    init <repo>          Initialize a new repository
-   list                 List all repos
+   list                 List all repositories
    run <repo> \\
        <command>        Use this repository
 
    seed-gitignore \\
    <repo>               Seed .gitignore.d/<repo> from git ls-files
+   use <repo>           Use repository; set ENV
 
    <repo> <git command> Special command that allows you to run git commands
                         directly without having to type so much ;)" >&2
-#   use <repo>     Use this repository
-#
-#   exit              Exit vcsh mode" >&2
 }
 
 debug() {
@@ -58,7 +57,7 @@ init() {
        mkdir -p "$GIT_WORK_TREE"
        cd "$GIT_WORK_TREE" ||
                (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                exit 20) || exit 20
+                return 1) || return $?
        cd "$GIT_WORK_TREE"
        git init
        git config core.worktree     "$GIT_WORK_TREE"
@@ -85,7 +84,8 @@ if [ "$1" = 'clone' ]; then
 elif [ "$1" = 'delete' ] ||
      [ "$1" = 'init' ] ||
      [ "$1" = 'run' ] ||
-     [ "$1" = 'seed-gitignore' ]; then
+     [ "$1" = 'seed-gitignore' ] ||
+     [ "$1" = 'use' ]; then
        [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
        export VCSH_COMMAND="$1"
        export VCSH_REPO_NAME="$2"
@@ -95,7 +95,8 @@ elif [ "$1" = 'delete' ] ||
        if [ "$VCSH_COMMAND" = 'run' ]; then
                [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
        fi
-elif [ "$1" = 'help' ] ||
+elif [ "$1" = 'exit' ] ||
+     [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
        export VCSH_COMMAND="$1"
 else
@@ -114,10 +115,10 @@ do
        if [ ! -d "$check_directory" ]; then
                if [ -e "$check_directory" ]; then
                        echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       exit 2
+                       return 2
                else
                        echo "$SELF: info: attempting to create $check_directory"
-                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; exit 2)
+                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
                fi
        fi
 done
@@ -138,9 +139,9 @@ if [ "$VCSH_COMMAND" = 'clone' ]; then
        [ "$VCSH_CONFLICT" = '1' ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-               exit 3
+               return 3
        git merge origin/master
-#      use || return 1
+#      use || return $?
        verbose "clone end"
 
 #elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
@@ -151,7 +152,7 @@ elif [ "$VCSH_COMMAND" = 'delete' ]; then
        verbose "delete begin"
        old_dir="$PWD"
        cd "$HOME"
-       use || return 1
+       use || return $?
        echo "$SELF: info: This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
@@ -161,7 +162,7 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
        read answer
-       [ "x$answer" = "xYes, do as I say" ] || exit
+       [ "x$answer" = "xYes, do as I say" ] || return 1
        for file in $files; do
                rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
        done
@@ -169,21 +170,21 @@ To continue, type \"Yes, do as I say\""
        cd "$old_dir"
        verbose "delete end"
 
-#elif [ "$VCSH_COMMAND" = 'exit' ]; then
-#      verbose "exit begin"
+elif [ "$VCSH_COMMAND" = 'exit' ]; then
+       verbose "exit begin"
 #      if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
 #              unset VCSH_NO_IGNORE_EOF
 #              setopt NO_IGNORE_EOF
 #      fi
-#      leave
+       leave
 #      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#      verbose "exit end"
-#      exit 0
+       verbose "exit end"
+       return 0
 
 elif [ "$VCSH_COMMAND" = 'init' ]; then
        verbose "init begin"
        init
-#      use || return 1
+#      use || return $?
        verbose "init end"
 
 elif [ "$VCSH_COMMAND" = 'list' ]; then
@@ -195,14 +196,14 @@ elif [ "$VCSH_COMMAND" = 'list' ]; then
 
 elif [ "$VCSH_COMMAND" = 'run' ]; then
        verbose "run begin"
-       use || return 1
+       use || return $?
        $VCSH_EXTERNAL_COMMAND
        leave
        verbose "run end"
 
 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        verbose "seed-gitignore begin"
-       use || return 1
+       use || return $?
        # Switching directory as this has to be executed from $HOME to be of any use.
        # Going back into old directory at the end in case `vcsh use` is reactivated.
        old_dir="$PWD"
@@ -216,7 +217,7 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
                done;
        done | sort -u)
        tempfile=$(mktemp) ||
-               (echo "$SELF: fatal: could not create tempfile" && exit 1) 
+               (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
        echo '*' > "$tempfile"
        for gitignore in $gitignores; do
                echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
@@ -228,15 +229,16 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
                echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
                mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" && exit 1)
+                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
+                        return 1) || return $?
        fi
        mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && exit 1)
+               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
        cd "$old_dir"
        verbose "seed-gitignore end"
 
-#elif [ "$VCSH_COMMAND" = 'use' ]; then
-#      verbose "use begin"
+elif [ "$VCSH_COMMAND" = 'use' ]; then
+       verbose "use begin"
 #      if [ -n "$ZSH_VERSION" ]; then
 #              if [ -o NO_IGNORE_EOF ]; then
 #                      export VCSH_NO_IGNORE_EOF=1
@@ -249,14 +251,14 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
 #              zle -N vcsh_exit
 #              bindkey '^d' 'vcsh_exit'
 #      fi
-#      use || return 1
+       use || return $?
 #      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-#      verbose "use end"
+       verbose "use end"
 
 else
        verbose "defaulting to calling help()"
        help
        echo "$SELF: fatal: You should never reach this code. File a bug, please."
-       exit 99
+       return 99
 
 fi